/**
 * Belongs to WordPress plugin: Image Projector
 */

;var wpip = wpip || function(){} 


"use strict";
(function ( $, window, document, undefined ) {

	$(document).ready(function() {	
			wpip.init();

			
	});	

wpip = {
		DND				: 0, // DoNotDisturb
		isOpen			: false,

		slowTimer		: 0,
		progressTimer	: 0,
		autoTimer		: null,	
		autoDo			: false,
		threed			: false,
		transitionEnd	: '',
		imageList		: '',
    cfg : {
		'bindto'			: '',
		'autoDuration'		: 3,  // secs	
		'expectedLoadtime'	: 6,  // secs	
		'slowMessage'		: '<p>Slow network or large image file?</p><br/><p>You may wait or refresh page...</p>',
		'fadeDuration'		: 500, // milliseconds
		'doNotScaleUp'		: false,
		'captions'			: false,
		'galleryWrappers'	: '',
		'cutImage'			: true, // for full width view
		'showRuler'			: false,
		'rulerColor'		: 'rgba(0, 147, 173, .6)',
		'showArrows'		: false,
		'imageMargin'		: 40,
		'thumbStripHeight'  : 82,
		'showThumbStrip'	: false,
		'initViewStyle'		: 1,
		'overlays'			: '',
		'excludeImg'		: '',
		'borderWidth'		: '20px',
		'borderColor'		: 'rgba(270, 270, 270, .7)',
		
		
		},
		
	wpdata : {
		
		'postString'		: '',
		'wpUploadUrl'		: '',
		'wpPluginUrl'		: '',
		'version'			: '',
		'isArchive'			: false,
		'phplog'			: '',
		'systemWrappers'	: ''
	
	},
	
	init : function() {

		if ( 'undefined' === typeof WPIVConfig )
		{
			// then something serious going on - quit
			return;
		}

		wpip.ui.hastouch = ipCheckTouch();		

		wpip.settings(WPIVConfig);

		if(wpip.ui.hastouch) {
			wpip.cfg.showRuler = false;
			wpip.cfg.showArrows = false;
		}
		
		wpip.ui.DOM();

		var bindto = 'img';
		
		if(wpip.cfg.bindto.length > 0) {
			// only images specified
			bindto = wpip.cfg.bindto;
		}
		if( wpip.cfg.overlays && wpip.cfg.overlays.length > 0) {
			bindto = bindto + ', ' + wpip.cfg.overlays;
		}
	
		$( "body" ).delegate(bindto, "click", function(e) {

			if(wpip.isOpen === true) {
				return;
			}

			var target = $( e.target )

			e.stopPropagation();
	
			// check if target is an element to exclude
			if(wpip.cfg.excludeImg && wpip.cfg.excludeImg.length > 0) {
				
				var exelems = wpip.cfg.excludeImg.toLowerCase().split(',');
				var l = exelems.length;
				var exelem = '';
				
				for (var i = 0; i < l; ++i) {
					
					exelem = exelems[i].slice(1);
					if(e.target.id.toLowerCase() === exelem) {
						return;
					}
					if($(e.target).hasClass(exelem)) {
						return;
					}	
				}
			}		

			// if clicked image is in a link that is not an image, follow link
			if(target.parent().is("a")) {
				url = target.parent().attr("href");
				if( ! ipIsImageFile(url))
				{
					return;
				}
			}
			e.preventDefault();
			
			// go ahead
			return(! wpip.start($(this)));
			
		});

	},
	
	settings : function(phpcfg){
	
		if (phpcfg && typeof(phpcfg) === 'object') {
			$.extend(this.cfg, phpcfg.cfg);
			$.extend(this.wpdata, phpcfg.wpdata);
		}
		
	},
	
	viewport : {
		currentmeta	: '',
		init : function() {
			var viewportmeta = document.querySelector('meta[name="viewport"]');
			if (viewportmeta) {
				this.currentmeta = viewportmeta.content;
				viewportmeta.content = 'width=device-width, minimum-scale=1.0, maximum-scale=1.0, initial-scale=1.0';
			}		
		},
		reset : function() {
			if(this.currrentmeta != '')
			{
				var viewportmeta = document.querySelector('meta[name="viewport"]');
				viewportmeta.content = this.currentmeta;
			}
		}
	},
	
	BUSY : function(newstatus) {

		if(typeof newstatus === 'undefined')
		{
			return this.DND;
		}
		if (newstatus === false) {
			this.DND = false;

			if(this.pendingResize) {
				this.pendingResize = false;
				this.windowresize();
			}
			if(this.pendingNavigate !== 0) {
				var dir = this.pendingNavigate;
				this.pendingNavigate = 0;
				this.slider.navigate(dir);				
			}
		} else {
			this.DND = true;
		}
	},
	
	start : function(img){

		if( ! img.is('img')) {
					
			// looking for nearby images, take the first if any
			// useful when an image is covered by an overlapping div and specified in cfg.bindto
			var siblings = img.siblings('img');
			if(siblings) {
					img = siblings.filter(':first');
				}else {

					return;
				}
		}

		wpip.viewport.init();
		
		if (wpip.collection.build(img) > 0) 
		{
			wpip.isOpen = true;
			wpip.ui.setup();
			wpip.ui.setavailablewindow();
			wpip.updatewrapper();

			$(document).trigger('showcurrent');
			return (true);
		}
		
		return (false);	
	},	
	
	collection : {

		items 	: Array(),
		current : 0,
		ref 	: false,  // for handling of global post array

		add: function(item) {
			var nitem = new ipItem();

			$.extend(nitem, item);
			this.items.push(nitem);
		},
		build: function (initImage) {
			
			var self = this;

			self.clear();

			// determine context of clicked image and create collection accordingly
			var galleryItems = wpip.getgallery(initImage);
			
			if (galleryItems > -1) { // belongs to a gallery
				 if(galleryItems === 0) {

					// gallery, but no valid image links, probably link to attachment page
					return false;
				 }
				 
			} else {
				var connection = wpip.connectpost(initImage);
				
				if(connection > -1) {
					
					if(wpip.wpdata.postString) {
						// from an archive page
						var arr=[];
						arr.push.apply(arr, wpip.wpdata.postString.split(",").map(Number));
						// filter out any archive items not connected to a particular image
						var connectionset = false;
						var alen = arr.length;
						var plen = wpiv_postarray.length;
						var i,j;
						for (i = 0; i < alen; i++) {
							for (j = 0; j < plen; j++) {
								if (arr[i] === wpiv_postarray[j][0])
								{
									self.add(self.getbyreference(j));

									if(j === connection && ! connectionset) {
										self.current = i;
										connectionset = true;
									}
								}
							}
						}

						if(typeof wpip.thumbstrip !== 'undefined') {
							wpip.setuparchivethumbs(arr);
						}
					}else {
						// an image from single post page or stream
						self.ref = true;
						self.current = connection;

					}
					
				}
			}

			$(document).trigger("countChange.ip",[self.count()]);			
			return(self.count());
		},
		_last: function() {
			var self = this;
			// last position in array
			return (self.ref ? wpiv_postarray.length -1 : self.items.length - 1);
		},
		_incr: function() {
			var self = this;
			return ((self.current + 1 > self._last()) ? 0 : self.current + 1);
		},
		_decr: function() {
			var self = this;			
			return ((self.current - 1 < 0) ? self._last() : self.current - 1);
		},
		count: function() {
			var self = this;
			// number of slides
			return (self.ref ? wpiv_postarray.length : self.items.length);
		},

		setLast: function() {
			var self = this;
			// set last item as current
			self.current = self._last();
		},
		set: function(num) {
			var self = this;
			// set num as current
			self.current = num;
		},	
		getItem: function(num) {
			var self = this;
			if('undefined' === typeof(num)) { 
				var num = self.current;
			}
			return(self.ref ? self.getbyreference(num) : self.items[num]);
		},
		getbyreference: function(num) {
			var self = this;
			
			var src	= wpiv_postarray[num][3];
			var nitem = new ipItem();
			if(src.indexOf("http") < 0 && src.indexOf("https") < 0)
			{	// file on this domain, path relative to wp upload dir
				src =  wpip.wpdata.wpUploadUrl + src;
			}
			$.extend(nitem, {
					width	: wpiv_postarray[num][1],
					height	: wpiv_postarray[num][2],
					src		: src,
					postid	: wpiv_postarray[num][0],
					seqno	: num});
			return(nitem);
		},
		getNextItem: function() {
			var self = this;
			return(this.getItem(self._incr()));
		},
		getPrevItem: function() {
			var self = this;
			return(this.getItem(self._decr()));
		},
		getadvance: function(direction) {
			var self = this;
			return(direction === 1 ? self._incr() : self._decr());
		},		
		goDirection: function(direction) {
			var self = this;
			self.current = (direction === 1) ? self._incr() : self._decr();
			return(self.current);
		},		

		clear: function() {
			var self = this;			

			self.ref = false;
			self.items = [];
			self.current = 0;			
		}					
	},
	setuparchivethumbs : function (arr) {

		var file = wpip.wpdata.wpPluginUrl+'/admin/ref/wpiv-ref-thumb-'+wpip.wpdata.version+'.json';


		wpip.thumbstrip._visible = true;
		
		function getthumbs(jfile, callback) {
			$.getJSON( jfile, function(returndata) {
				callback(returndata, arr);
			});
		}
		
		getthumbs(file,function(returndata, arr) {
			var thumbs = Array();	
			var alen = arr.length;

			for (var i = 0; i < alen; i++) {
							
				var src = wpip.wpdata.wpUploadUrl + returndata[arr[i]].name;
				var ratio = returndata[arr[i]].ratio;
				if(ratio === 0) ratio = 1;
				thumbs.push({name:src,ratio:ratio});
			}
			wpip.activatethumbstrip(thumbs);

		});

	},
	activatethumbstrip : function (thumbs) {
			var self = this;
			var visible = true;
			var toggler = wpip.thumbstrip.buildstrip(thumbs, wpip.collection.current, visible);
			
			wpip.ui.el.shallautohide.push(toggler);
			$(toggler).css({display:'block'});
			
			if(wpip.cfg.showRuler && typeof wpip.ruler !== 'undefined') {
				wpip.ruler.show(false);
				wpip.cfg.showRuler = false;
			}


	},
	guessgallery : function (img, generations) {
		var exhausted = false;
		var parent = $(img).parent();
		var current = $(img);
		var currenttag, siblings;

		var ancestors = 1;
		do {
			if(parent && (ancestors <= generations && $(parent).prop("tagName").toLowerCase() != 'body')){
				currenttag	= $(current).prop("tagName");
				siblings	= $(current).siblings(currenttag).andSelf();
				
				if($(parent).find('img').length > 1 && siblings)
				{
					exhausted = true;
				} else {
					current	= parent;
					parent	= $(current).parent();
					ancestors ++;
				}
			} else {
				exhausted = true;
			}
			
		}
		while( ! exhausted);

		// siblings could be a list of sibling images or aunts and uncles
		return(siblings);
	
	},
	getgallery : function(initImage) {
		var global 			= this;
		var found 		 	= -1;
		var count 			=  0;
		var img				= '';
		var wrappers 		= [""];
		var mergedwrappers	= "";
		var gwrap			= "";
		var src 			= "";
		var href 			= "";
		var clickedsrc		= "";
		var srcname			= "";
		var images 			= "";
		var zero			= true;
		var gallery 		= "";
		var combine			= "";
		var aAlt			= "";
		var anchor			= "";
		var thumbs 			= Array();
		
		// check if any elements above the clicked image has any of the specified class or IDs specified as wrapper
		if(wpip.cfg.galleryWrappers.length > 0) { combine = ', ';}
		
		mergedwrappers = wpip.cfg.galleryWrappers + combine + wpip.wpdata.systemWrappers;
		wrappers = mergedwrappers.split(',');
		
		for (var i = 0, l = wrappers.length; i < l; ++i) {
			gwrap = wrappers[i];
			gwrap = gwrap.trim();
			gallery = $(initImage).parent().closest(gwrap);
			if(gallery.length > 0) 
			{
				zero = false;
				images = $(gallery).find('img');				
				break;
			}
		}

		// possible fallback if wrapper name is not defined and image is not a post image - have a look around...	 
	 	if(zero && wpip.wpdata.postString.length === 0 && ! $(initImage).data('postid') ) {

			gallery = this.guessgallery(initImage, 20);

			if(gallery) {
				if($(gallery).first().prop('tagName').toLowerCase() != 'img') {
					images = $(gallery).find('img');
				} else {
					images = gallery;
				}
				zero = false;
			}
		} 
		 
		// if zero is true, then no gallery found
		if(zero) return(found);
		
		// keep for reference
		clickedsrc = initImage.attr('src');

		// so, from here images will contain the image elements
		var imgparent = "";		
		images.each(function() {
			
				img = $(this);
				imgparent = $(this).parent();
				
				thumbs.push({name:$(img).attr("src"),ratio:1});
				
				if($(imgparent).prop("tagName").toLowerCase() == 'a') {
					href = imgparent.attr('href');

					// get the alt-attribute for later use
					aAlt = imgparent.attr('alt');
					
					if(href) {
						// remove any url parameters from href string
						href = ipCleanURL(href);

						// the thumb image element contained in the anchor
						if(ipIsImageFile(href)) {
							src = href;
						} else {
							src = $(img).attr("src");
						}
					}
				} else {
					src = $(img).attr("src");
				}
				
				if (typeof img.data('orig-src') !== 'undefined')  {
						// could be jetpack tiled gallery
						// remove any parameters from image src string
						src = ipCleanURL(img.data('orig-src'));	

				}

				if(src !== "") {
					count++;
					var caption	= "";					
					var dTitle = ""; // any data-title attribute on image
					var dDesc = ""; // any data-description attribute on image
					var dCaption = ""; // any envira-caption attribute on image
					
					var iAlt= ""; // alt attribute on image
					var iTitle= ""; // title attribute on image

					iAlt = img.attr("alt");
					iTitle	= img.attr("title");
					
					if (typeof img.data('title') !== 'undefined')  
					{
						var dTitle = img.data('title');
					}
					
					if (typeof img.data('description') !== 'undefined')  
					{
						var dDesc = img.data('description');
					}
					if (typeof img.data('envira-caption') !== 'undefined')  
					{
						var dCaption = img.data('envira-caption');
					}							
					if(dTitle && !iAlt && dTitle.length > 0) {
						caption = dTitle;
					}else if(iAlt && iAlt.length > 0){
						caption = iAlt;
					}else if(iTitle && iTitle.length > 0){
						caption = iTitle;
					}else if(aAlt && aAlt.length > 0) {
						caption = aAlt;
					}
					
					if(dCaption && dCaption.length > 0){
						caption = dCaption;
					}

					srcname = src.substring(src.lastIndexOf('/') + 1); // get the last part of image URL
					srcname = srcname.substr(0, srcname.lastIndexOf('.')); // get rid of extension

					// the thumb in the gallery compared with clicked image
					if(clickedsrc.toLowerCase().lastIndexOf(srcname.toLowerCase()) !== -1) {

						wpip.collection.current = count - 1; // zero based

					}

					wpip.collection.add({
							width	: 0,
							height	: 0,
							src		: src,
							postid	: 0,
							seqno	: count - 1, // zero based
							alt		: caption
						});
					found = count;
				} 
			}); // each of the images inside wrapper
			
		if(typeof wpip.thumbstrip !== 'undefined' && thumbs.length > 1) {
			wpip.activatethumbstrip(thumbs);
		}			
		return (found);
	},
	
	connectpost : function (img) {
		var postid 		= "";		
		var pos			= -1;
		var found 		= false;
		var i, src;

		if (typeof wpiv_postarray === 'undefined') return(-1);
		
		var n = wpiv_postarray.length;
		
		if(n === 0) return(-1);
		
		if(typeof img.data('ippostid') !== 'undefined') {
			postid 	= img.data("ippostid");
		} else {
			postid 	= parseInt(img.data("postid"));
		}		

		src = ipCleanURL(img.attr("src"));
		
		function getsrc(n) {
			return (wpiv_postarray[n][3]);
		}
		function getpostid(n) {
			return (wpiv_postarray[n][0]);
		}
		
		if (src.length > 0) {
				if(postid !== undefined) {
					for (i = 0; i < n; i++) {
						if (postid === getpostid(i) && src.lastIndexOf(getsrc(i)) !== -1) {
								pos = i;
								found = true;
								break;
							}
					}
					if(!found) {
						for (i = 0; i < n; i++) {
								if (postid === getpostid(i)) {
								pos = i;
								break;
							}
						}
					}	
				}else {
					for (i = 0; i < n; i++) {
							if (src.lastIndexOf(getsrc(i)) !== -1) {
							pos = i;
							break;
						}						
					}
				}
		}
		
		return (pos);

	},

	ui : {

		numslides		: 3,
		captionInactive : false,
		captionON		: false,
		showArrows		: false,
		arrowsON		: false,
		menuON			: false,
		bckStyle		: 1,
		viewStyle		: 1,
		hastouch		: false,
		mousechecked	: false,
		ctrl			: false,
		navnum			: 0,
		
		el : Array(),
		DOM: function() {
			
			var self 		= this;
			var el			= self.el;
			var ulparent 	= 'body';
			var ulclass		= 'ip-underlay-full';
			var i, html;
			var numslides 	= self.numslides;
			
			html = '<div id="image-projector">' 
			html+= '<div id="ip-underlay" class="grabbable '+ulclass+'">';


			// image wrapper 
			html+= '<div id="ip-image-container">';
			
			// add img elements to switch between, inside the image wrapper

			for (i = 0; i < numslides; i++) {
				html+='<div id="ip-slide-'+(10+i)+'" class="ip-slide"><span class="ip-slide-copyright"></span><img id="img-' + (10+i) + '" src=""/></div>';
			}  	
			
			// end of ip-image-container
			
			html+= '</div>';

			// an overlay
			html+= '<div id="ip-overlay" class="grabbable">';

			// overlay content wrapper, slow loading message
			html+= '<div id="overlay-wrapper" class="overlay-wrapper-hide">';
			
			html+= '<div id="overlay-content"><div id="overlay-message">'+wpip.cfg.slowMessage+'</div></div></div>';
			
			// end of ip-overlay
			html+= '</div>';
			
			// menu items
			var items = [];

			var iconSizeClass = '';
			var mclass = '';
			var cmdView		= ['ip-view','Switch view style','Cycle view styles',''];
			var cmdBck		= ['ip-bck','Switch bright/dark background','Background','md-i-bck'];
			var cmdCaption	= ['ip-caption-toggle','Show captions','Captions','md-i-capts'];
			var cmdTrans	= ['ip-transition','Togggle between crossfade and slide','Transition style','md-i-trans-slide'];
			var cmdLast		= ['ip-last','Go to last image','Last image','md-i-last'];			
			var cmdAuto		= ['ip-play','Auto play','Auto','md-i-play'];
			var cmdExit		= ['ip-exit-cmd','Exit viewer','Exit','md-i-exit'];
			
			// decide the menu markup
			if( ! wpip.ui.hastouch) {
				
				mclass = 'xmenu-desktop';
				iconSizeClass = 'md-sz-menu-desktop';
				
				items.push(cmdView);
				items.push(cmdBck);

				if(wpip.cfg.captions) {
					items.push(cmdCaption);
				}
				items.push(cmdTrans);
				items.push(cmdLast);
				items.push(cmdAuto);
				items.push(cmdExit);
			} else {

				mclass = 'xmenu-touch';
				iconSizeClass = 'md-sz-menu-touch';
				
				if(wpip.cfg.captions) {
					items.push(cmdCaption);
				 }
				items.push(cmdView);
				items.push(cmdBck);				 
				items.push(cmdLast);
				items.push(cmdAuto);
			}
			
			var mi = items.length;
			var baseClasses = 'ip-cmd ip-cmd-active';
			var aiconclass	= 'material-icons mi-align';
			var xms	= '';			
			// generate menu markup
			for (i = 0;i < mi;i++) {
				xms = xms + '<li id="'+items[i][0] +'" class="' + baseClasses +  ' ' + iconSizeClass + '"><i class="'+aiconclass+' '+items[i][3] +'"></i>'+ (! wpip.ui.hastouch ? '<span>'+items[i][2]+'</span>' : '') +'</li>';
			}

			
			// standard floating buttons
			aiconclass = " ip-floating-button material-icons md-sz-floating mi-align ip-button-color ";

			var stdbuttons = [	{'id':'ip-exit',		'title':'Close',		'icon':'&#xE5CD'},
								{'id':'ip-goto-post',	'title':'Go to post',	'icon':'&#xE89E'},
								{'id':'ip-menu-toggle',	'title':'Menu',			'icon':'&#xE5D2'},
								{'id':'ip-zoom-on',		'title':'Zoom',			'icon':'&#xE8FF'},
								{'id':'ip-arrow-left',	'title':'Previous',		'icon':'&#xE314'},
								{'id':'ip-arrow-right',	'title':'Next',			'icon':'&#xE315'}
								];
			
			html+='<div id="ip-floating-buttons">';
			
			stdbuttons.forEach(function(item) {
				html+='<div id='+item.id+' title='+item.title+' class="'+item.id+aiconclass+'">'+item.icon + ';</div>';
				
			});

			// counter
		 	//html+='<div id="ip-counter" title="Counter" class="ip-counter ip-button-color ip-floating-button"></div>';
			
			// zoom buttons
			var zoombuttons = [	{'id':'ip-zoom-off',	'title':'Zoom off',	'icon':'&#xE166'},
								{'id':'ip-zoom-out',	'title':'Zoom out',	'icon':'&#xE900'},
								{'id':'ip-zoom-in',		'title':'Zoom in',	'icon':'&#xE8FF'}];

			aiconclass = " ip-cmd-hide ip-floating-button material-icons md-sz-floating mi-align ip-button-color-zoom";
			zoombuttons.forEach(function(item) {
				html+='<div id='+item.id+' title='+item.title+' class="'+item.id + aiconclass +'">'+item.icon + ';</div>';
				
			});

			// text item showing current zoom 
			html+='<div id="ip-zoom-current" title="Current zoom" class="ip-zoom-current ip-button-color-zoom ip-cmd-hide ip-floating-button"></div>';

			// caption support, if set in plugins admin menu
			if(wpip.cfg.captions) {

				html+='<div id="ip-caption" unselectable="on">';
				html+='<div id="ip-caption-text" unselectable="on"></div></div>';

			}	
			html+='</div>'; // end of floating buttons
			html+='</div>'; // end of underlay
			
			// append the menu markup
			html+= '<div id="ip-xmenu" class="ip-xmenu ' + mclass + '"><ul>'+xms+'</ul></div>';


			// add a loader to show if user tries to advance while loading

			html+= '<div id="ip-loader">';
			for (var i = 1; i < 5; i++) {
				html+= '<span class="ip-loader__dot"></span>';
			}
			html+= '</div>';
			
			html+="</div>"; // end of image-projector
			
			
			
			// insert into top of document body
			$(ulparent).prepend(html);
			
			//
			// cache
			//
			var un			= "body>#image-projector>#ip-underlay";

			el.ipwrapper 	= $("body>#image-projector");
			el.underlay 	= $(un);
			el.wrapper		= $(un+">#ip-image-container");
			el.imgall		= $(un+">#ip-image-container img");
			el.allslides	= $(un+">#ip-image-container>.ip-slide");
			el.overlay		= $(un+">#ip-overlay");
			el.slowtext		= $(un+">#ip-overlay>#overlay-wrapper");


			var mul 		= "body>#image-projector>#ip-xmenu>ul";			
			// menu and menu items
			el.xmenu			= $("body>#image-projector>#ip-xmenu");			
			el.bckswitch   		= $(mul+">#ip-bck");
			el.style			= $(mul+">#ip-view");
			el.transition		= $(mul+">#ip-transition");
			el.auto				= $(mul+">#ip-play");
			el.last				= $(mul+">#ip-last");
			el.captiontoggle  	= $(mul+">#ip-caption-toggle");

			
			var fl			= "body>#image-projector>#ip-underlay>#ip-floating-buttons";
			// floating elements
			el.menutoggle	= $(fl+">#ip-menu-toggle");			
			el.exit			= $(fl+">#ip-exit");
			el.openpost		= $(fl+">#ip-goto-post");
			el.next			= $(fl+">#ip-arrow-right");
			el.prev			= $(fl+">#ip-arrow-left");
			el.exit.i		= $(fl+">#ip-exit");
			
		 	el.zoomin		=  $(fl+">#ip-zoom-in");
		 	el.zoomout		=  $(fl+">#ip-zoom-out");
		 	el.zoomon		=  $(fl+">#ip-zoom-on");
		 	el.zoomoff		=  $(fl+">#ip-zoom-off");
		 	el.zoomcurrent	=  $(fl+">#ip-zoom-current");

			// caption elements
			if(wpip.cfg.captions) {
				el.caption		= $(fl+">#ip-caption");
				el.captiontext	= $(fl+">#ip-caption>#ip-caption-text");
			}
			
			// menu icons that may be changed during operation
			el.style.icon	= $(mul+">#ip-view>i");
			el.auto.icon	= $(mul+">#ip-play>i");
			el.auto.span 	= $(mul+">#ip-play>span");
			el.transition.icon	= $(mul+">#ip-transition>i");

			el.shallautohide = [ 
					el.menutoggle,
					el.exit,
					el.prev,
					el.next,
					el.zoomon
					];

			if(wpip.ui.hastouch) {

				el.menutoggle.css({"display":"none"});
			}

			for (i = 0; i < numslides; i++) {		  
				wpip.slider.SLIDES.push($(un+'>#ip-image-container>#ip-slide-' + (10 + i)));
			}
			
			if(wpip.cfg.showRuler && ! wpip.ui.hastouch) {
				wpip.ruler = el.underlay.ipruler({"color":wpip.cfg.rulerColor});
			}
			
			if(wpip.cfg.showThumbStrip && ! wpip.ui.hastouch) {
				wpip.thumbstrip = el.ipwrapper.ipthumbstrip({"stripheight":wpip.cfg.thumbStripHeight, "uploadurl":wpip.wpdata.wpUploadUrl});

			}
			
			wpip.bindeventhandlers();
	
		},
	
		setup : function() {
			
			var self 	= this;
			var EL		= self.el;
			
			wpip.BUSY(true);
			self.setavailablewindow();
			// ctrl-key is not down
			self.ctrl = false;
			wpip.panstarted = false;
			wpip.pendingNavigate = 0;			
			wpip.pendingResize = false;
			wpip.ui.navnum = 0;
			wpip.ui.viewStyle = parseInt(wpip.cfg.initViewStyle);
			wpip.cookie.read();
	
			wpip.busyloading.off();
		
			if(!self.hastouch) {
				wpip.ui.switchbackground(wpip.ui.bckStyle);
			} else {
				wpip.ui.switchbackground(1);
			}
			

			wpip.transDuration = Math.round(10 * parseInt(wpip.cfg.fadeDuration) / 1000) / 10;

			if(ipHasTranslate3d()){
				wpip.threed = true;
			}

			wpip.transitionEnd = ipWhichTransitionEnd();

			
			wpip.slider.iscrossfade = false;
			wpip.zoom.off();

			EL.allslides.css({'opacity':0.0,'transtion':'none','transform':'none'});
			EL.imgall.attr('src','');
			EL.transition.icon.swapclass('md-i-trans-cross','md-i-trans-slide');
			EL.transition.swapclass("ip-cmd-inactive", "ip-cmd-active");
			EL.auto.swapclass("ip-cmd-inactive", "ip-cmd-active");
			EL.last.swapclass("ip-cmd-inactive", "ip-cmd-active");
	
			// do not allow some functions when one image and not in post array, neutralize the buttons
			if(wpip.collection.count() < 2 && ! wpip.collection.ref) {

				EL.transition.swapclass("ip-cmd-active", "ip-cmd-inactive");				
				EL.auto.swapclass("ip-cmd-active", "ip-cmd-inactive");
				EL.last.swapclass("ip-cmd-active", "ip-cmd-inactive");
			}

			wpip.captions.load();

			if(wpip.collection.getItem().postid > 0){
				EL.openpost.css({"display":"block"}).attr({"title":"Go to post #"+wpip.collection.getItem().postid});
				EL.menutoggle.removeClass("ip-no-goto");
				wpip.ui.el.shallautohide.push(wpip.ui.el.openpost);				
			} else {
				EL.menutoggle.addClass("ip-no-goto");
				
			}

			wpip.ui.showArrows = wpip.cfg.showArrows;
			wpip.ui.showarrows(true);
	
			// set up default view style
			if(!self.hastouch) {
				wpip.ui.switchview(wpip.ui.viewStyle);
			} else {
				wpip.ui.switchview(3);
			}
			
			// set context menu height
			if( EL.xmenu.hasClass('xmenu-desktop')) {
				var lis = EL.xmenu.find('li');
				var num = lis.length;
				
				EL.xmenu.css({'height':num * lis.first().outerHeight() + 'px'});
			}
			
			// this is reset when closing viewer
			wpip.handlekeypress(); 
		
			// specify elements that shall be faded out after a while as long as no mousemove or tapping occurs
			wpip.ui.autohide.init(EL.shallautohide);
					
			wpip.ui.autohide.activate();
		
			// and here we go...
			EL.ipwrapper.css({'display':'block','opacity':1,'transition':'opacity .3s linear'});

		},
	setavailablewindow : function () {
		var stripvisible 	= false;

		wpip.availW 	= parseInt(wpip.ui.el.ipwrapper.innerWidth());
		wpip.availH 	= parseInt(wpip.ui.el.ipwrapper.innerHeight());
		
		if(typeof wpip.thumbstrip !== 'undefined') {
			stripvisible = wpip.thumbstrip.isvisible();
		}

		if (stripvisible) {wpip.availH = wpip.availH - wpip.cfg.thumbStripHeight};
	
	},
	getavailablewindow : function () {
		return	({'w':wpip.availW, 'h':wpip.availH});
	},
		
		switchview: function(viewno) {

			var os 	 	= wpip.ui.viewStyle;
			var vs 		= os;
			
			if(wpip.autoDo || wpip.zoom.active)
			{
				return false;
			}
			
			if(viewno === undefined) {
				vs = (vs < 3) ? vs + 1 : 1;
			} else {
				vs = (viewno > 3) ? 3 : viewno;
			}

			wpip.ui.el.wrapper.swapclass('ip-view' + os, 'ip-view' + vs);

			wpip.ui.el.style.icon.swapclass('md-i-view' + os, 'md-i-view' + vs);

			wpip.ui.viewStyle = vs;

			if( wpip.cfg.showRuler && ! wpip.ui.hastouch && typeof wpip.ruler !== 'undefined') {
				wpip.ruler.show(vs === 3 ? false : true);
			}

			wpip.cookie.write();
			
			return true;
		},
		
		switchbackground : function(bck) {
			
			var self = this;			
			var styles = ['ip-underlay-dark','ip-underlay-bright'];
			
			self.bckStyle = (bck !== undefined) ? parseInt(bck) : (self.bckStyle === 1) ? 2 : 1;

			self.el.ipwrapper.removeClass(styles[self.bckStyle===2?0:1]).addClass(styles[self.bckStyle===2?1:0]);

			wpip.cookie.write();
		},

		showmenu : function(showit) {
			var self = this;

			if(showit === self.menuON) return;
			
			self.menuON = showit ? true:false;

			if( ! self.menuON) {

				self.el.xmenu.removeClass("active");
			}else {

				self.el.xmenu.addClass("active");
			}

			return;
		},
		positionmenu: function(x, y) {
			
			var winW 	= $(window).width();
			var winH 	= $(window).height();
			var menu 	= wpip.ui.el.xmenu;
			
			var menuH	= menu.outerHeight();
			var menuW	= menu.outerWidth();
			var l, t;
			var offset  = window.pageYOffset || $('body').scrollTop();

			if(x + menuW - winW > 0) {
				// menu to the left
				l = x - menuW + 1 + 'px';
			} else {
				// to the right
				l = x - 1 + 'px';

			}
			if(y - offset + menuH - winH > 0) {
				// menu above pointer
				t = y - offset - menuH + 1 + 'px';
				if(y - offset - menuH < 0) {
					t = 0;
				}
			} else {
				// below pointer
				t = y - 1 - offset + 'px';
			}
			
			
			menu.css({'left':l,'top':t});			
	
		},

		showarrows : function (showit) {
			
			
			var self = this;
			var canshow = ( ! self.hastouch && showit && wpip.collection.count() > 1 && wpip.ui.showArrows);

			$('#ip-arrow-left, #ip-arrow-right').css({'display':canshow ? 'block':'none'});
			self.arrowsON = showit;
		},

		autohide : {
			activityState:false,
			userActivity	: true,
			activityCheck	: null,
			inactivityTimeout : null,

			el: Array(),

			init: function(elems) {
				var self = this;
				self.el = elems;
				
				//http://blog.videojs.com/Hiding-and-Showing-Video-Player-Controls/

				wpip.ui.el.underlay.on('mousemove', function(){
					self.userActivity = true;	
				});

				wpip.hammerhandler.manager.on("tap", function(){
					self.userActivity = true;
				});

			},

			deactivate: function() {
				var self = this;
				
				clearTimeout(self.inactivityTimeout);
				clearInterval(self.activityCheck);				
			},
			
			activate: function() {
				var self = this;
				self.activityCheck = setInterval(function() {

				  // Check to see if the mouse has been moved
				  if (self.userActivity) {

					// Reset the activity tracker
					self.userActivity = false;
				
					// If the user state was inactive, set the state to active
					if (self.activityState === false) {
					  self.userActive(true);
					}

					// Clear any existing inactivity timeout to start the timer over
					clearTimeout(self.inactivityTimeout);

					// In X seconds, if no more activity has occurred 
					// the user will be considered inactive
					self.inactivityTimeout = setTimeout(function() {
					  // Protect against the case where the inactivity timeout can trigger
					  // before the next user activity is picked up  by the 
					  // activityCheck loop.
					  if (!self.userActivity) {
						self.userActive(false);
					  }
					}, 2000);
				  }
				}, 250);
				
			},
			
			userActive: function(active) {

				var self = this;
				if(active !== undefined) {
					switch(active) {
						case true:
							self.el.forEach(function (item) {
							  item.removeClass("user-inactive");
							});
							break;
						case false:
							self.el.forEach(function (item) {
							  item.addClass("user-inactive");
							});						
							break;
					 }
					 self.activityState = active;
				 }
				return(self.activityState);
			},
			teardown: function() {
				var self = this;
				self.deactivate();

			}
		}
	},

	captions : {
		
		captionlist	: Array(),
		set : function() {
			
			var EL		= wpip.ui.el;
			var coll 	= wpip.collection;
			
			if(wpip.cfg.captions) {
				var ctext	= "";
				var postid	= coll.getItem().postid;
				ctext = postid > 0 ? this.captionlist[postid] : coll.getItem().alt;
				EL.captiontext.html( ! ctext || ctext === "" ? "Untitled" : ctext);
			}
		},
		load : function() {
			
			var self 	= this;

			if(wpip.cfg.captions) {

				var jfile = wpip.wpdata.wpPluginUrl+'/admin/ref/wpiv-ref-c-'+wpip.wpdata.version+'.json';

				jQuery.getJSON( jfile, function( data ) {
					jQuery.each( data, function( key, val ) { 
						self.captionlist[key]=val;
					});
				});
				wpip.ui.el.captiontext.html("");
			}
		},		
		fadeout : function() {
			
			var el = wpip.ui.el;
			
			if(wpip.cfg.captions) {
				el.captiontext.fadeTo('fast', 0.0);
				el.captiontext.html("");
			}
		},
		show : function(showit){
			
			var ui = wpip.ui;
			
			if( ! wpip.cfg.captions) return;
			
			ui.captionON = showit ? true:false;
			if(ui.captionON) {
				ui.el.caption.addClass("ip-in-service");
			}else {
				ui.el.caption.removeClass("ip-in-service");
			}
		},		
		donotshowagain : function() {
			
			var self = this;
			wpip.ui.captionInactive = true;
			self.show(false);
		},		
		teardown : function() {
			this.captionlist = [];
		}
	},
	
 	startstop : function() {
		

		if(wpip.zoom.active || wpip.collection.count() < 2) return;

		
		var EL = wpip.ui.el;

		var duration = parseInt(wpip.cfg.autoDuration)*1000;
		if( ! wpip.BUSY() || wpip.autoDo) { // if busy, it can only be stopped
			if( ! wpip.autoDo) {
					wpip.autoDo = true;
					EL.zoomon.addClass("ip-cmd-inactive");
					EL.auto.icon.swapclass('md-i-play', 'md-i-playing');
					EL.style.swapclass("ip-cmd-active", "ip-cmd-inactive");
					EL.transition.swapclass("ip-cmd-active", "ip-cmd-inactive");
					EL.auto.span.text("Stop");
					autoNext();
				} else {
					EL.zoomon.removeClass("ip-cmd-inactive");
					EL.auto.icon.swapclass('md-i-playing', 'md-i-play');
					EL.style.swapclass("ip-cmd-inactive", "ip-cmd-active");
					EL.transition.swapclass("ip-cmd-inactive", "ip-cmd-active");
					EL.auto.span.text("Auto");					
					wpip.autoDo = false;
					clearTimeout(wpip.autoTimer);
					wpip.autoTimer = null;
				}
		}
		function autoNext() {
			if(wpip.autoDo) {
				wpip.autoTimer = setTimeout(function(){
						if( ! wpip.autoDo) { 
							clearTimeout(wpip.autoTimer);
							wpip.autoTimer = null;
						}else
						{

							if( ! wpip.panstarted) {
								// if user has not started to pan
								wpip.slider.navigate(1);
							}
						}
						autoNext();

				}, duration);
			}
		}		
		return;
	},
	busyloading : {
		elems : "#ip-underlay, #ip-overlay, .ip-floating-button",
		on : function() {
			if( ! wpip.ui.hastouch ) {
					$(this.elems).addClass("cursor-busy")
				} else {
					$("#ip-loader").css({"display":"block"});
			}		
		},
		off : function() {
			if( ! wpip.ui.hastouch ) {
					$(this.elems).removeClass("cursor-busy")
				} else {
					$("#ip-loader").css({"display":"none"});
			}		
		}
	},
	slider : {
		SLIDES: [],
		iscrossfade: false,
		extra: 20,
		init : function() {
			
			
			wpip.BUSY(true);
			
			var self = this;
			var coll = wpip.collection;
			var optrans	= 'opacity ' + wpip.transDuration + 's linear';
			var item = coll.getItem();
			var img;

			self.numslides = wpip.ui.el.wrapper.find(".ip-slide").length;

			self.currentslide = (self.numslides - 1 ) / 2;
			
			img = self.midslide().find('img');
			
			wpip.startProgressTimer();
			item.load(img);
			
			// preload next while loading initial
			if(coll.count() > 1) {

				var iA = self.leftslide();
				var iC = self.rightslide();
				
				
				coll.getPrevItem().load(iA.find('img'));
				coll.getNextItem().load(iC.find('img'));

				
				var itrans = 0;
				$('img').one("imageloaded", function(e) {

					if(++itrans === 3) {
						preloaded();

					}
				});

				function preloaded() {

					self.arrangeslides();

					if( ! self.iscrossfade) {
						iA.css({'opacity':'1'});
						iC.css({'opacity':'1'});
					}	 			
				}
			}
			// end preload
			img.one("imageloaded", function(event) {

				wpip.clearProgressTimer();

				wpip.fitimage(false, img);

				$(document).trigger("currentchange.ip",[coll.current]);

				self.midslide().css({'opacity':'1','transition': optrans});

				self.midslide().one(wpip.transitionEnd, function(event) {
					self.midslide().css({'transition': 'none'});
					wpip.BUSY(false);
					wpip.captions.set();
				});

			});
			
		},		
		leftslide: function () {

			return($(this.SLIDES[this.currentslide - 1]));

		},
		midslide: function () {

			return($(this.SLIDES[this.currentslide]));

		},			
		rightslide: function () {

			return($(this.SLIDES[this.currentslide + 1]));

		},
	
		alignright : function() {
			
			var self = this;
			var w = wpip.ui.el.wrapper.innerWidth();
			var slide = self.rightslide();
			
			if( ! self.iscrossfade) {

				slide.css({"left" : w +  self.extra});
				slide.css({"display":"block"});
			}else {
				// crossfade
				slide.css({"left" : Math.floor((w - slide.outerWidth()) / 2)});			
			}
		},
		alignleft : function() {
			
			var self = this;
			var w = wpip.ui.el.wrapper.innerWidth();
			var slide = self.leftslide();
			if( ! self.iscrossfade) {

				slide.css({"left" : -1 * slide.outerWidth() - self.extra});
				slide.css({"display":"block"});
			}else {
				// crossfade
				slide.css({"left" : Math.floor((w - slide.outerWidth()) / 2)});
			}
		},
		arrangeslides : function() {
			// resize and reposition adjacent images
			
			var self 	= this;
			var first 	= self.leftslide();
			var last 	= self.rightslide();

			if(first.attr("src") != "") {
				wpip.resizeimage(first.find('img'));
				self.alignleft();

			}
		
			if(last.attr("src") != "") {
				wpip.resizeimage(last.find('img'));
				self.alignright();

			}

		},
		navigateto : function(num) {
			
			var coll	= wpip.collection;
			var self 	= this;
			var dir;

			if(num > coll.current) {
				dir = 1;
				slide = wpip.slider.rightslide().find('img');
			}else {
				dir = -1;
				slide = wpip.slider.leftslide().find('img')
			}

			
			wpip.collection.current = num - dir;
			wpip.slider.preloaditem(wpip.collection.getItem(num), slide);

			$(document).one('preloadedImage.ip', function(e) {
				wpip.clearProgressTimer();
				wpip.slider.advance(dir);
				wpip.slider.update();
				$(document).trigger("currentchange.ip",[coll.current]);
			});
			wpip.ui.navnum++;			
		},
		navigate : function(direction) {
			
			var coll	= wpip.collection;
			var self 	= this;
			
			if(coll.count() < 2 || wpip.zoom.active) {
				return;
			}
			if(wpip.BUSY()) {
				if( ! wpip.autoDo) {
					wpip.pendingNavigate = direction;
					wpip.busyloading.on();
				}
				return;
			}

			wpip.ui.navnum++;

			self.advance(direction);
			
			$(document).trigger("currentchange.ip",[coll.current]);
		},
		advance : function(dir) {
			
			wpip.BUSY(true);
			
			var self 	= this;
			var wrpW, prevW, newW, divIn, divOut, divPending;
			var extra = self.extra;
			
			wpip.collection.goDirection(dir);

			divIn  		= (dir === -1) ? self.leftslide()  : self.rightslide();
			divPending	= (dir === -1) ? self.rightslide() : self.leftslide();
			divOut 		= self.midslide();
			
			var imageelem = divIn.find('img');
			
			wpip.collection.getItem().load(imageelem);

			imageelem.one("imageloaded", function(event) {

				wpip.slider.alignleft();
				wpip.slider.alignright();
				if(self.iscrossfade) {
					pendingFinish = true;
					self.crossfade(divIn, divOut);
				}else {
					
					wrpW	= wpip.ui.el.wrapper.innerWidth();
					newW 	= divIn.outerWidth();

					prevW = divOut.outerWidth();

					if(dir === -1) { // swiping right
						 inMoveDistance = newW + Math.floor((wrpW - newW) / 2) + extra;
						outMoveDistance = wrpW - Math.floor((wrpW - prevW) / 2) + extra;
					pendingMoveDistance = inMoveDistance;
					}else { // swiping left
						 inMoveDistance = -Math.floor((wrpW + newW) / 2) - extra;
						outMoveDistance = -Math.floor((wrpW + prevW) / 2) - extra;
					pendingMoveDistance = inMoveDistance;						
					}
					
					     divIn.slidexy(inMoveDistance,      0, wpip.threed, true);
					    divOut.slidexy(outMoveDistance,     0, wpip.threed, true);
	
				}
				
				wpip.captions.fadeout();
				
				wpip.clearProgressTimer();
				var num = self.iscrossfade ? 2 : 2;
				var itrans = 0;
				
				$('.ip-slide').one(wpip.transitionEnd, function(e) {

					if( ++itrans === num) {

						if( ! self.iscrossfade) {
								divOut.setleft(    divOut.position().left);
								
								 divIn.setleft(     divIn.position().left);
							divPending.setleft(divPending.position().left);
							
						}
						var ovl = wpip.ui.el.overlay;
						var sz = wpip.getsizeandposition(divIn.find('img'));
						
						ovl.sizeandcenter(sz.ovl, false); 
						
						self.update();
						swapImages();
						
						$(document).one('preloadedImage.ip', function(e) {			
							wpip.BUSY(false);
							
							$(document).trigger("navigatecompleted.ip");
							wpip.busyloading.off();
						});
					}
				}); 
				
			});	
			function swapImages() {
				var SLIDES 	= self.SLIDES;
				var itemNew;

				if(dir === 1) {
					SLIDES.push(SLIDES.shift()); // 0,1,2 -> 1,2,0 rotating from right to left
					itemNew = wpip.collection.getNextItem();

				}
				else {
					SLIDES.unshift(SLIDES.pop()); // 0,1,2 -> 2,0,1 rotating from left to right
					itemNew = wpip.collection.getPrevItem();

				}
				if( ! self.iscrossfade) {
					// place rightmost image outside right side of wrapper
					self.alignright();					
				}
				// preload next item
				imgtoload =	(dir === 1) ? self.rightslide().find('img') : self.leftslide().find('img');

				self.preloaditem(itemNew, imgtoload );

			} // swapped

		},
		preloaditem : function (item, img) {
				
				var self = this;
				var id = '#' + img.attr("id");

				item.load(img);

				$(id).one("imageloaded", function(event) {

					wpip.resizeimage(img);
					preLoaded();
				});
				
				// align the loaded hidden item ready for next navigation
				function preLoaded() {
					if( ! self.iscrossfade) {
						// place leftmost image outside left side of wrapper
						self.alignleft();
					}

					$(document).trigger("preloadedImage.ip");					
				}		
			
		},
		crossfade : function(divIn, divOut) {
				
			var optrans = 'opacity ' + wpip.transDuration + 's linear';
		
			divOut.css({'opacity':0.0,'transition': optrans});
			divIn.css({'opacity':1.0,'transition': optrans});
		},
		
		showlast : function()
		{
			var self = this;
			
			self.show(wpip.collection._last());

		},
		show : function(num)
		{
			// go to an iage specified by the sequence number
			if(wpip.BUSY() || wpip.zoom.active) {return false;}

			$(document).trigger("navigateto.ip",[num]);
			
			return true;
		},
		pan: function(ev) {

			if( ! wpip.slider.iscrossfade)
			{
				wpip.ui.el.allslides.slidexy(ev.deltaX, 0, wpip.threed, false);
			}
		
		},
		panend: function(ev) {
			
			var self 	= this;			
			var dir 	= 0;
			var slideHome = false;

			if(ev.direction & Hammer.DIRECTION_LEFT) {
				dir =  1
				 
				if( ! wpip.slider.iscrossfade) {

					var boff = self.leftslide().position().left;

					 // move to initial position if panned outside in opposite direction
					if(boff > 0 || boff +  self.leftslide().prop("width") > 0) {
						slideHome = true; // send it home 
					} 
				}
				 
			}
			if(ev.direction & Hammer.DIRECTION_RIGHT) {
				dir = -1
				 
				if( ! wpip.slider.iscrossfade) {
					var lastleft = self.rightslide().position().left - wpip.ui.el.wrapper.innerWidth();
					var boff = self.midslide().position().left;
					
					// move to initial position if panned outside in opposite direction
					if(boff < 0 || lastleft < 0) {
						slideHome = true; // send it home 
					}			
				}
			}
			if (dir === 0 || (slideHome  || Math.abs(ev.distance) < 5))
			{
				// go back to initial position, not panning enough
				wpip.ui.el.allslides.slidexy(0, 0, wpip.threed, true);
				
			} else {
				wpip.slider.navigate( dir );
			}


		},
		
		switchtransitionstyle : function(newstyle) {
			
			if(wpip.BUSY()) {return;}
			var EL				= wpip.ui.el;
			var self			= this;

			if(typeof newstyle === 'undefined') {
				
				newstyle = self.iscrossfade ? false:true;
			
			}
			if( newstyle ) {

					self.iscrossfade = true;			
					EL.transition.icon.removeClass('md-i-trans-slide').addClass('md-i-trans-cross');
					self.leftslide().css({"opacity":0.0,'transition':'none'});
					self.rightslide().css({"opacity":0.0,'transition':'none'});
					self.alignright();
					self.alignleft();


			}else {
					self.iscrossfade = false;
					EL.transition.icon.removeClass('md-i-trans-cross').addClass('md-i-trans-slide');
					self.alignright();
					self.alignleft();			
					
					wpip.ui.el.allslides.css({"opacity":1.0,'transition':'none'});					
			}

		},

		
		update : function() {
				
			var EL		= wpip.ui.el;
			var coll	= wpip.collection;
			
			if(wpip.cfg.captions) {
				wpip.captions.set();
				EL.captiontext.fadeTo('fast', 1.0);
			}
			EL.openpost.attr({"title":"Go to post #" + coll.getItem().postid})

			if(coll.current === 0) {
				
			}
		
		},		

	},
	handleevents : function () {
		
		var preH=0,  preW=0;
		$(document).on('showcurrent.ip', function(e) {
			wpip.slider.init();

		});

		// change of current image is done in plugin
		$(document).on('navigateto.ip', function(e, current) {
			wpip.ui.showmenu(false);
	
			if(current !== wpip.collection.current && ! wpip.BUSY()) {
				wpip.slider.navigateto(current);
			}

		});		

		$(document).on('drag.ip dragstart.ip', (function(e) {
			e.preventDefault();
			return false;
		}));

		// orientation of hand-held device changed, wait for new width and height to be settled
		$( window ).on('orientationchange', (function(e) {
			if( ! wpip.isOpen) return;

			setTimeout( function() {
				wpip.windowresize();
				$(document).trigger('ipresized');

			}, 1000);

		}));

		$( window ).on('debouncedresize', (function(e) {
			if( ! wpip.isOpen) return;

			if(Math.abs(preH  - $(window).height()) > 3 || Math.abs(preW - $(window).width()) > 3) {
				preH = $(window).height();
				preW = $(window).width();

				wpip.windowresize();
				$(document).trigger('ipresized');

			} else {
				// ignore minimal debounceresize
				preH = 0;
				preW = 0;
			} 

		}));

		
		$(window).on('doipresize', function(e) {

			wpip.windowresize();
		}),
		
		$(wpip.ui.el.underlay).on('wheel.ip', function(e) {

			var delta = e.originalEvent.deltaY;
			wpip.ui.showmenu(false);
			if( ! wpip.zoom.active) {
				
				wpip.slider.navigate( delta > 0 ? 1 : -1);

			}else {
				
				wpip.zoom.scalebyfactor(delta < 0 ? 1 : -1);

				return false; 			
			}

			return false; 
		});	

	},
	startProgressTimer : function() {
		
		
		if(wpip.progressTimer === 0) {
			wpip.progressTimer = setTimeout(function () {wpip.showloader();}, 300);
		}
	},
	
	clearProgressTimer : function() {
		
		var EL = wpip.ui.el;
		
		if(wpip.progressTimer !== 0) {
			clearTimeout(wpip.slowTimer);
			clearTimeout(wpip.progressTimer);
			EL.overlay.css("background-image","none");
			EL.slowtext.addClass("overlay-wrapper-hide").removeClass("overlay-wrapper-show");
			wpip.slowTimer		= 0;
			wpip.progressTimer	= 0;
		}
		
	},

	showloader : function() {
		
		var EL = wpip.ui.el;
		
		EL.overlay.css("background-image","url('"+wpip.wpdata.wpPluginUrl+"/public/img/wpiv-loader.gif')");
		wpip.slowTimer = setTimeout(function () {
				showSlow()},
				parseInt(wpip.cfg.expectedLoadtime)*1000
			);
		
		function showSlow() {
			
			EL.slowtext.addClass("overlay-wrapper-show").removeClass("overlay-wrapper-hide");
		}
	},
	hammerhandler : {
		manager: null,

		init: function() {
			var self = this;
			
			wpip.panstarted = false;

			self.manager = new Hammer.Manager(document.getElementById("ip-underlay"), {
				recognizers: [
					[Hammer.Pan, {direction: Hammer.DIRECTION_ALL }],
					[Hammer.Swipe,{ direction: Hammer.DIRECTION_ALL }],																							  
					[Hammer.Tap],
					[Hammer.Pinch, { enable: true }]
				]
			});

			self.manager.set({ touchAction: 'none' });
			
			self.manager.on("tap", function(ev) {

				if(! $(ev.target).hasClass('ip-cmd') && ! $(ev.target).hasClass('material-icons')) {
					if(wpip.ui.menuON) {
						wpip.ui.showmenu(false);
						
					} else if(! wpip.zoom.active && ! wpip.autoDo && ! wpip.BUSY() && (ev.target.id == 'ip-underlay' || ev.target.id == 'image-projector' || ev.target.id == 'ip-image-container' || ev.target.id == 'ip-floating-buttons'))
					{
						wpip.reset();
					}
				}
			});

			self.manager.on("pinchout pinchin", function(ev) {
				if(wpip.zoom.active) {
					wpip.zoom.pinch(ev);
				}
			});	
		
			self.manager.on("pinchstart", function(ev) {
				if( ! wpip.zoom.active && ! wpip.autoDo && ! wpip.BUSY()) {
					wpip.zoom.on();
				}

				wpip.zoom.pinchstart(ev);
			});
			
			self.manager.on("pinchend pinchcancel", function(ev) {
				if(wpip.zoom.active) {
					wpip.zoom.pinchend(ev);
				}
			});	
			self.manager.on("panstart", function(ev) {

				if ( wpip.panstarted ) {
					// there is already a pan operatin going on 
					return;
				}
				if( ! wpip.ui.ctrl && ((! wpip.zoom.active && wpip.collection.count() < 2) || wpip.zoom.prevent_pan))
				{	// no pan to start if not scaling and only one slide or pan is prevented
					return;
				}
				if(wpip.ui.ctrl && wpip.autoDo) 
				{	// no scale by panning while playing
					return;
				}				
			
				if(! wpip.BUSY() && ! $(ev.target).hasClass('ip-cmd') && ! $(ev.target).hasClass('material-icons')) {
					if (wpip.ui.menuON) {
						wpip.ui.showmenu(false);
					}

					wpip.panstarted = true;
			
				}

			});
			
			self.manager.on("panleft panright panup pandown", function(ev) {
				if( ! wpip.panstarted ) {
					// if pan not registered as started
					return;
				}
				
				if( ! wpip.zoom.active && ! wpip.ui.ctrl) {
					// 1. slide 
					wpip.slider.pan(ev);
				} else if(wpip.ui.ctrl && (ev.direction & Hammer.DIRECTION_UP)) {
					// 2. scale, enter zoom mode if ctrl-key is down
					wpip.zoom.on();
					wpip.zoom.pan(ev);
				} else if(wpip.zoom.active) {
					// 3. pan wen zoom active
					wpip.zoom.pan(ev);
				}

			});	

			self.manager.on("panend", function(ev) {
				
				// pan start may be prevented if trying to pan while advancing
				// if panstarted is false, panend shall not be triggered
				
				if( ! wpip.panstarted &&  wpip.BUSY()) {

					if(wpip.pendingNavigate === 0) {
						var dir = 0;
						if(ev.direction & Hammer.DIRECTION_LEFT) {
							dir =  1;
						} else if (ev.direction & Hammer.DIRECTION_RIGHT) {
							dir = -1;
						}
						
						if(dir !== 0) wpip.busyloading.on();
						
						wpip.pendingNavigate = dir;
					}
					return;
				}
				
				wpip.panstarted = false;
				
				if(wpip.zoom.active) {
					wpip.zoom.panend(ev);
				} else{
					if(! wpip.zoom.prevent_pan) {
						wpip.slider.panend(ev);
					}
				}
			});
		},
		teardown: function() {
			self.manager.destroy();
			delete self.manager;
		}
	},

	handleclicks : function () {
		
		var EL = wpip.ui.el;


		EL.underlay.on('contextmenu.ip',  function(e){ 
			contextmenuclicked(e);
			return false; 

		 });

		$( document ).delegate('#ip-thumbstrip-outerwrapper, .ip-thumbwrapper', 'contextmenu.ip', function(e) {
			contextmenuclicked(e);
			return false; 

		}); 
 
		// handling menu clicks
		 $('.ip-cmd').on('click', function(e) {

			e.stopPropagation();
			var thisID =  $(this).attr('id');
			
			if ( $(this).hasClass("ip-cmd-inactive")) {
				return;
			}		
			if(thisID == 'ip-view' && ! wpip.autoDo && ! wpip.BUSY()) {
				wpip.ui.switchview();
				
				wpip.updatewrapper();
				wpip.fitimage(false);
				wpip.slider.arrangeslides();
				
			}else if(thisID == 'ip-transition') {
				wpip.slider.switchtransitionstyle();
			}else if(thisID == 'ip-last') {
				wpip.slider.showlast();
			}else if(thisID == 'ip-bck') {
				wpip.ui.switchbackground();
			}else if(thisID == 'ip-play') {
				wpip.startstop();
			}else if(thisID == 'ip-exit-cmd') {
				wpip.ui.showmenu(false);
				wpip.reset();
			}
		});

		// handling button clicks
		 $('.ip-floating-button').on('click', function(e) {
			e.stopPropagation();
			
			var thisID =  $(this).attr('id');
			if ( $(this).hasClass("ip-cmd-inactive")) {
				return;
			}
			if(thisID == 'ip-goto-post') {
				wpip.gotopost();
			}else if(thisID == 'ip-exit') {
				wpip.reset();
			}else if(thisID == 'ip-zoom-in') {
				wpip.zoom.scalebyfactor(1);
			}else if(thisID == 'ip-zoom-out') {
				wpip.zoom.scalebyfactor(-1);
			}else if(thisID == 'ip-zoom-on') {
				wpip.ui.showmenu(false);
				wpip.zoom.scalebyfactor(1);
			}else if(thisID == 'ip-zoom-off') {
				wpip.zoom.off();
			}else if(thisID == 'ip-menu-toggle') {
					wpip.ui.positionmenu(e.pageX, e.pageY);
					wpip.ui.showmenu(! wpip.ui.menuON);
			}else if(thisID == 'ip-arrow-left') {
				wpip.ui.showmenu(false);
				wpip.slider.navigate(-1);
			}else if(thisID == 'ip-arrow-right') {
				wpip.ui.showmenu(false);
				wpip.slider.navigate(1);
			}
		});
	 
		// toggle display of captions
		if(wpip.cfg.captions) {
				EL.caption.on('click',  function(e){
				e.stopPropagation();
				wpip.captions.donotshowagain();
			
			});
			
			EL.captiontoggle.on('click',  function(e){
				e.stopPropagation();
				wpip.captions.show(! wpip.ui.captionON ? true : false);
				wpip.ui.captionInactive = false;

			});
		}
		
		// doubleclick on/off zoom mode
		EL.overlay.on('dblclick',  function(e){
			e.stopPropagation();
			if( ! wpip.zoom.active && ! wpip.autoDo && ! wpip.BUSY()) {

				wpip.zoom.scalebyfactor(1);
				
			} else if(wpip.zoom.active) {
				wpip.zoom.off();
			}
		});

		// right-click opens menu
		function contextmenuclicked(e) {
			if(! wpip.ui.menuON) {
				if(wpip.zoom.active) {
					wpip.zoom.off();
				}
				wpip.ui.positionmenu(e.pageX, e.pageY);
				wpip.ui.showmenu(! wpip.ui.menuON);
			}else
				{
					wpip.ui.positionmenu(e.pageX, e.pageY);
				}
			 return false; 
		}
	},
	
	handlekeypress : function () {
		
		var UI = wpip.ui;
		// keys, shortcut keys
	
		$(document).on('keyup.ip', (function(e) {

			e.stopPropagation();

			switch (e.keyCode) {
				
				case 17: // Ctrl-key up
					wpip.ui.ctrl = false;
					break;
				case 84: // T - switch transition style
					wpip.slider.switchtransitionstyle();
					break;
				case 88: // X - eXit
					wpip.reset();
					break;
				case 65: // A - Auto
				case 80: // P - Play				
					wpip.startstop();
					break;
				case 37: // Left arrow
					wpip.slider.navigate(-1);
					break;
				case 39: // Right arrow
					wpip.slider.navigate( 1);
					break;
				case 76: // L - Last
					wpip.slider.showlast();
					break;
 				case 83: // S - Style
				case 86: // V - View
				case 89: // Y - stYle
					if( ! wpip.autoDo && ! wpip.BUSY()) {
						UI.switchview();
						wpip.updatewrapper();					
						wpip.fitimage(false);
						wpip.slider.arrangeslides();
					}
					break;
				case 66: // B - Background
					UI.switchbackground();
					break;
				case 67: // C - Captions
					if(wpip.cfg.captions) {				
						wpip.captions.show(! UI.captionON ? true : false);
					}
					break;						
				case 90: // Z - Zoom on/off
					if(!wpip.zoom.active) {
						wpip.zoom.on();
					} else {

						wpip.zoom.off();
					};
					break;
				case 187: //+ zoom in
					if( wpip.zoom.active) {
						wpip.zoom.scalebyfactor(1);
					}				
					break;
				case 189: //- zoom out
					if( wpip.zoom.active) {
						wpip.zoom.scalebyfactor(-1);
					}				
					break;					
			}
		}));

		$(document).on('keydown.ip', (function(e) {
			// Ctrl-key down
			if (e.keyCode === 17  && ! wpip.ui.ctrl) {
				wpip.ui.ctrl = true;
			}

			// disable down/up arrow keydown to avoid scrolling
			if (e.keyCode === 40 || e.keyCode === 38) {
				return false;
			}						
				
		}));

	},

	bindeventhandlers : function(){
		
		
		wpip.hammerhandler.init();
		wpip.handleclicks();
		wpip.handleevents();
	},

	windowresize : function() {
		// if busy, do the resize later
		if(wpip.BUSY()) {
			wpip.pendingResize = true;
			return;
		}
		
		wpip.ui.setavailablewindow();
		wpip.ui.showmenu(false);

		wpip.updatewrapper(true);  // true means animate
		wpip.fitimage(true);

		if( ! wpip.slider.iscrossfade) {

			// hide them before arrangeslides()
			wpip.slider.leftslide().css({"display":"none"});
			wpip.slider.rightslide().css({"display":"none"});
		}

		wpip.ui.el.wrapper.one(wpip.transitionEnd, function(event) {
			wpip.slider.arrangeslides();
		});
		
		if(wpip.zoom.active) {
			wpip.zoom.off();
			
		}

	},

	resizeimage : function(img) {
		
		
		// resize image when loaded or loaded images not yet in view or window resized
		var sz = wpip.getsizeandposition(img);
		
		img.parent().css({"top":sz.img.t+'px',"width":sz.img.w+'px',"height":sz.img.h+'px'});

		return (sz);
	
	},

	fitimage : function(anim, img) {

		
		var ovl = wpip.ui.el.overlay;

		if(typeof img === 'undefined')	img = wpip.slider.midslide().find('img');
		if(typeof anim === 'undefined') anim = true;

		var sz = wpip.getsizeandposition(img);

		img.parent().sizeandcenter(sz.img, anim);
		
		ovl.sizeandcenter(sz.ovl, false); 
		
		return(sz);
	},
	updatewrapper : function(animate) {
		
		var wrp 			= wpip.ui.el.wrapper;
		var margin 			= wpip.cfg.imageMargin;
		var css 			= {};

		var asz				= wpip.ui.getavailablewindow();
		var availW 			= asz.w;
		var availH 			= asz.h;

		if(typeof animate === 'undefined') animate = false;

		if(wpip.ui.viewStyle === 1)
		{
			// inside square
			var winSquare=Math.min(availW - margin, availH - margin);
			css.l = Math.floor((availW - winSquare)/2);
			css.t = Math.floor((availH - winSquare)/2);
			css.h  = winSquare;
			css.w  = winSquare;
			wrp.sizeandcenter(css, animate);
			
		}else {

			css.l = 0;
			css.t = 0;
			css.w  = availW;
			css.h  = availH;	
			wrp.sizeandcenter(css, animate);
		}			
		
	},

	getsizeandposition : function($img) {
		// calculate image sizes and position
		
		var EL				= wpip.ui.el;
		var margin 			= wpip.cfg.imageMargin;
		var w, h, hScale, wScale, pScale, imgH, imgW, imgL, imgT, ovlT, ovlL, ovlW, ovlH;
		
		
		if(typeof $img === 'undefined') return;

		var asz 	= wpip.ui.getavailablewindow();
		var availW	= asz.w;
		var availH	= asz.h;
		
		w = parseInt($img.attr("width"));
		h = parseInt($img.attr("height"));

		if(wpip.ui.viewStyle === 1)
		{
			// inside square
			var winSquare=Math.min(availW - margin, availH - margin);
			
			hScale = winSquare / h;
			wScale = winSquare / w;
			
			pScale = Math.min(hScale, wScale);

			imgW = Math.floor(w * pScale);
			imgH = Math.floor(h * pScale);
			
			imgL = Math.floor((winSquare-imgW)/2);
			imgT = Math.floor((winSquare-imgH)/2);

			ovlH  = winSquare;
			ovlW  = winSquare;
			ovlT  = Math.floor((availH - winSquare)/2);
			ovlL  = Math.floor((availW - winSquare)/2);

		}
		
		else if (wpip.ui.viewStyle === 2)
		{
			// with border
			//$img.css({"border-width":wpip.cfg.borderWidth});
			
			var b  = Math.floor(($img.outerWidth()-$img.innerWidth())/2);
			var bb = 2*b;
	
			hScale = (availH - margin - bb)/(h+bb);
			wScale = (availW - margin - bb)/(w+bb);
				
			pScale = Math.min(hScale, wScale);

			imgW = Math.floor((w + bb) * pScale);
			imgH = Math.floor((h + bb) * pScale);
			
			if(wpip.cfg.doNotScaleUp) {
				imgW = Math.min(w, imgW);
				imgH = Math.min(h, imgH);
			}
			
			imgL = Math.floor((availW - imgW) / 2);
			imgT = Math.floor((availH - imgH) / 2);

			ovlH  = imgH+bb;
			ovlW  = imgW+bb;
			ovlT  = imgT;
			ovlL  = imgL;

		}		
		else {
			
			// full throttle!			
			hScale = (availH) / h;
			wScale = (availW) / w;
			
			pScale = Math.min(hScale, wScale);
			
			imgW = Math.round(w*pScale);
			imgH = Math.round(h*pScale);
	
			if( wpip.cfg.cutImage === true)  {
				var gutterHeight = (availH - imgH);
				var gutterWidth = (availW - imgW);
				var gutterHRatio = 100 * Math.abs(gutterHeight) / availH;
				var gutterWRatio = 100 * Math.abs(gutterWidth) / availW;

				if(gutterHRatio < 20 && gutterWRatio < 20) {
					pScale = (gutterHRatio < gutterWRatio) ? wScale : hScale;
					imgW = Math.round(w*pScale);
					imgH = Math.round(h*pScale);				
				}
			} 
			
			imgL = Math.floor((availW - imgW)/2);
			imgT = Math.floor((availH - imgH)/2);
			
			ovlH  = imgH;
			ovlW  = imgW;
			ovlT  = imgT;
			ovlL  = imgL;

		}

		var sizes = {
			'img':{'w':imgW,'h':imgH,'t':imgT,'l':imgL,'scale':pScale},
			'ovl':{'w':ovlW,'h':ovlH,'t':ovlT,'l':ovlL,'scale':pScale}
		}	

		return sizes;
	},

	zoom : {
		active: false,
		factor: 1,
		maxscale: 5,
		initscale: 1,
		accumulated_scaletravel: 0,
		accumulated_pinchscale: 0,

		accumulated_x:0,
		accumulated_y:0,
		max_scaletravel:1000,
		step_scaletravel:10,
		currx:0,
		curry:0,
		centerOffsetY: 0,
		centerOffsetX: 0,
		prevent_pan:false,
		
		togglecontrols : function(show) {
			
			var EL = wpip.ui.el;

			if(show) {
				EL.exit.hidecmd();
				EL.menutoggle.hidecmd();
				EL.zoomon.hidecmd();
				if(wpip.collection.getItem().postid > 0) {
					EL.openpost.hidecmd();
				}
				EL.zoomoff.showcmd();
				EL.zoomcurrent.showcmd();
				EL.zoomout.showcmd();
				EL.zoomin.showcmd();

			} else {
		
				EL.zoomon.showcmd();
				EL.exit.showcmd();
				EL.menutoggle.showcmd();
				if(wpip.collection.getItem().postid > 0) {
					EL.openpost.showcmd();
				}
				EL.zoomoff.hidecmd();				
				EL.zoomcurrent.hidecmd();			
				EL.zoomout.hidecmd();
				EL.zoomin.hidecmd();

			}
			
		},
		constraints: {
			allowedmove_x : 0,
			allowedmove_y : 0,
			initww: 0,
			initwh: 0,
			imgw: 0,
			imgh: 0,
			rescale: false,
			
			init: function() {
				
				var self = this;
				var EL = wpip.ui.el;
				var img = wpip.slider.midslide().find('img');


				self.initww = EL.wrapper.outerWidth();
				self.initwh = EL.wrapper.outerHeight();
				
				self.imgw =  img.outerWidth();
				self.imgh =  img.outerHeight();

				wpip.zoom.initscale = parseInt(img.attr("width")) / self.imgw;
				self.imgOffsL = img.offset().left;
				self.imgOffsT = img.offset().top;
			},
			
			set: function() {
				
				var self = this;
				var img = wpip.slider.midslide().find('img');
				var fullw = Math.round(self.imgw * wpip.zoom.factor);
				var fullh = Math.round(self.imgh * wpip.zoom.factor);

				self.allowedmove_y = Math.round(Math.abs(Math.round((self.initwh - fullh) / 2)) / wpip.zoom.factor);
				self.allowedmove_x = Math.round(Math.abs(Math.round((self.initww - fullw) / 2)) / wpip.zoom.factor);
				

			}
		},

		on: function() {
			
			var UI = wpip.ui;
			var self = this;

			if(self.active || wpip.autoDo) return false;
			
			if(typeof wpip.thumbstrip !== 'undefined') { 

				wpip.thumbstrip.hide();
			}
			if(typeof wpip.ruler !== 'undefined')
			{
				wpip.ruler.hide();
			}			
			
			// setting scale by pan resolution
			var sh = screen.height;

			// using screen height 1080 as basis
			self.step_scaletravel = 10 * sh / 1080;

			UI.autohide.userActive(false);
			UI.autohide.deactivate();

			self.togglecontrols(true);
			
			self.active = true;
			self.oldScale = 1;
			self.prevent_pan = false;
			
			self.currx = 0;
			self.curry = 0;
			self.accumulated_scaletravel = 0;
			self.accumulated_pinchscale = 0;

			self.accumulated_x = 0;
			self.accumulated_y = 0;

			self.constraints.init();

			self.factor = 1;
			self.constraints.set();
			
			self.rescale = false;
	
			return true;
		},
		pinchstart : function(ev) {
			var self = this;

			self.prevent_pan = true;
			self.accumulated_pinchscale = self.factor;
		},
		pinch : function(ev) {
			var self = this;
			var delta = 0;

			delta = self.factor * (ev.scale - 1);

			self.accumulated_pinchscale = Math.max(1, Math.min(self.maxscale, self.factor + delta));			

			self.updateimage(self.currx, self.curry, self.accumulated_pinchscale);
			self.updateicons(self.accumulated_pinchscale);
		},
		pinchend : function(ev) {
			var self = this;
			
			self.factor = self.accumulated_pinchscale;
			self.constraints.set();
			self.removegaps();
			self.updateimage(self.currx, self.curry, self.factor, false);
			self.updateoverlay(self.currx, self.curry, self.factor);
			self.updateicons(self.accumulated_pinchscale);			
	
			var step = (self.maxscale - 1) / self.max_scaletravel;
			self.accumulated_scaletravel = (self.factor - 1) * step;
			self.prevent_pan = false;
			
			if(self.factor <= 1) {
				self.off();
			}
		},

		pan : function(ev) {
			
			var self = this;

			var deltax, deltay;
			var travelx, travely;

			var maxx = self.constraints.allowedmove_x;
			var maxy = self.constraints.allowedmove_y;
			var accumulated_scale = self.accumulated_scaletravel;
			var accumulated_x = self.accumulated_x;
			var accumulated_y = self.accumulated_y;
			
			// prevent pan when terminating pinch scale to avoid any jumps in image
			if(self.prevent_pan) {
				return true;
			}

			function scalebypan(travel) {
				var step = (self.maxscale - 1) / self.max_scaletravel;
				self.factor = Math.min(5,1 + (step * travel));
				if(self.factor <= 1) {
					self.off();
				} else {				
					self.updateicons(self.factor);
				}
			}		
			
			// if ctrl-key is not pressed, do pan rather than zoom
			if( ! wpip.ui.ctrl) {

				travelx = ev.deltaX / self.factor;
				travely = ev.deltaY / self.factor;
				
				deltax = travelx;
				deltay = travely;
				
				// prevent panning outside boundaries

					// vertically
					if(travely > 0) {
						if(accumulated_y + travely > maxy) {

							deltay = maxy - accumulated_y;
						}
					}else if(travely < 0) {
						if(accumulated_y + travely < -1 * maxy) {

							deltay = -1 * maxy - accumulated_y;
						} 
					}
					// horizontally
					if(travelx > 0) {
						if(accumulated_x + travelx > maxx) {

							deltax = maxx - accumulated_x;
						}
					}else if(travelx < 0){
						if(accumulated_x + travelx < -1 * maxx) {

							deltax = -1 * maxx - accumulated_x;
						} 
					}						

				self.curry = accumulated_y + deltay;
				self.currx = accumulated_x + deltax;
				
			} else {
				// ctrl-key is pressed, scaling by panning up or down
				if(ev.direction & Hammer.DIRECTION_UP) {

					if(accumulated_scale < self.max_scaletravel - self.step_scaletravel)
					{
						self.rescale = true;
						accumulated_scale += self.step_scaletravel;
					}else {
						accumulated_scale = self.max_scaletravel;
					}
					
				}else if(ev.direction & Hammer.DIRECTION_DOWN) {
					if(accumulated_scale > self.step_scaletravel)
					{
						self.rescale = true;
						accumulated_scale -= self.step_scaletravel;
					}else {
						accumulated_scale = 0;
					}
				}
				
				if(self.rescale) {
					scalebypan(accumulated_scale);

					self.constraints.set();
					self.removegaps();
					self.accumulated_scaletravel = accumulated_scale;

				}

			}
			
			self.updateimage(self.currx, self.curry, self.factor);
		},
		panend: function (ev) {
			
			var self = this;

			self.updateoverlay(self.currx, self.curry, self.factor);
			
			self.accumulated_y = Math.floor(self.curry);
			self.accumulated_x = Math.floor(self.currx);
			
			self.rescale = false;
			self.prevent_pan = false;

			var img = wpip.slider.midslide().find('img');
		
		},
		
		
		
		scalebyfactor : function(direction) {
			
			var self = this;
			var img = wpip.slider.midslide().find('img');
			var incr = 0.5;


			self.oldScale = self.factor;

			self.prevent_pan = false;
			
			if( ! self.active) {
				self.on();
			}
			
			if(direction === 1) {
				if(self.factor + incr > self.maxscale) {
					self.factor = self.maxscale;
					
				}else {
					self.factor += incr;
				}
			}else {

					if(self.factor - incr < 1) {
						self.factor = 1;
										
					}else {
						self.factor -= incr;
					}
	
			}
		
			self.updateicons(self.factor);
			self.accumulated_scaletravel = self.max_scaletravel * (self.factor - 1) / (self.maxscale - 1);
			self.constraints.set();


			self.removegaps();

			self.updateimage(self.currx, self.curry, self.factor, true);
			self.updateoverlay(self.currx, self.curry, self.factor);	
						
			self.constraints.set();

		},
		
		updateimage: function(x, y, scale, ease) {
			
			var self = this;
			var img = wpip.slider.midslide().find('img');
			
			if(ease) wpip.BUSY(true);
			
			
			var trans = (ease) ? "transform 0.4s ease" : "transform 0.0s"; // to ease or not to ease, that's the question

			img.css({'transition':trans,'transform':ipGetTransformScale(scale, wpip.treed)+ ' '+ipGetTransformTranslate(x, y, wpip.treed)});
			
			img.one(wpip.transitionEnd, function(e) {
				wpip.BUSY(false);

 			});
			
		},
		updateicons : function(scale) {
			
			var self = this;
			var EL = wpip.ui.el;
			
			if(wpip.ui.hastouch) {return;}
			
			if(self.factor > 1) {
				if(self.factor === self.maxscale) {
					EL.zoomin.addClass("ip-cmd-inactive");	
				} else {
					EL.zoomin.removeClass("ip-cmd-inactive");
				}
				
				EL.zoomout.removeClass("ip-cmd-inactive");			
			}else {
					EL.zoomin.removeClass("ip-cmd-inactive");	
					if(self.factor === 1) {
						EL.zoomout.addClass("ip-cmd-inactive");	
					}				
			}
			EL.zoomcurrent.html(Math.round(scale * 100) + "%");
		},		
		removegaps : function() {
			var self = this;
			var ax = self.constraints.allowedmove_x;
			var ay = self.constraints.allowedmove_y;
			
			// prevent gaps horizontally
			if(self.curry > 0 && self.curry > ay) {
				self.curry = ay;
			}else if(self.curry < 0 && -1*self.curry > ay) {
				self.curry = -1 * ay;
			}
			
			// prevent gaps vertically
			if(self.currx > 0 && self.currx > ax) {
				self.currx = ax;
				
			}else if(self.currx < 0 && -1*self.currx > ax) {
				self.currx = -1 * ax;
			}		

			self.accumulated_y = self.curry;		
			self.accumulated_x = self.currx;
				
				
		},

		
		updateoverlay: function(x, y, scale) {
			

			wpip.ui.el.overlay.css({'transition':'transform','transform':ipGetTransformScale(scale, wpip.treed)+ ' '+ipGetTransformTranslate(x, y, wpip.treed)});
			
		},
		
		off: function() {
			
			var self = this;
			
			if(!self.active) return;
			
			var img = wpip.slider.midslide().find('img');

			self.togglecontrols(false);

			self.active = false;
			self.factor = 1;
		
			wpip.ui.el.overlay.css({'transition':'none','transform':'none'});
			img.slidexy(0, 0, wpip.threed, true);

			img.one(wpip.transitionEnd, function(event) {
				img.css({"transform":"none"});
				img.css({'transform-origin':'50% 50%'});						
			});
			wpip.ui.autohide.activate();
			wpip.ui.autohide.userActive(true);
			self.centerOffsetY = 0;
			self.centerOffsetX = 0;			
			
			// to prevent any undesired pan actions immediately after exit from zoom
			setTimeout(function(){
					wpip.zoom.prevent_pan = false;
				}, 500);
				
			if(typeof wpip.thumbstrip !== 'undefined') {
				wpip.thumbstrip.unhide();
			}			

			if(typeof wpip.ruler !== 'undefined')
			{
				wpip.ruler.unhide();
			}					
		}
	},
	cookie : {
		name : '_imageprojector',
		
		write : function() {
						
			var UI = wpip.ui;
			var self = this;

			var arr = [UI.viewStyle, UI.captionON, true, UI.bckStyle];

			document.cookie = self.name + "=" + JSON.stringify(arr) + "" + "; expires=Fri, 31 Dec 9999 23:59:59 GMT; path=/";
		},
		
		read : function() {
			
			var self = this;
			var json_str = self.get();
		
			if(json_str !== "" && json_str !== undefined) {

				var arr = JSON.parse(json_str);
				if(arr.length === 4){   
					wpip.ui.viewStyle	= arr[0];
					wpip.ui.bckStyle	= arr[3];
				}
			}
		},
		
		get : function() {
			var self = this;
			
			if (document.cookie.length > 0) {
				c_start = document.cookie.indexOf(self.name + "=");
				if (c_start !== -1) {
					c_start = c_start + self.name.length + 1;
					c_end = document.cookie.indexOf(";", c_start);
					if (c_end === -1) {
						c_end = document.cookie.length;
					}
					return unescape(document.cookie.substring(c_start, c_end));
				}
			} else {return ("");};			
		}
	},
	
	gotopost : function() {
		
		var postid = wpip.collection.getItem().postid;
		
		wpip.reset();

		$(document).trigger("closed.ip",['Exit to ' + postid]);
		
		if(postid > 0) {
			window.location.href = window.location.protocol + "//" + window.location.host + "?p=" + postid;
		}

	},
	
	reset : function() {
		
		var navnum = wpip.ui.navnum;
		
		$(document).trigger("closed.ip",['Exit after ' + (navnum + 1) + ' views']);
		
		wpip.destroy();
		wpip.viewport.reset();

	},
	
	destroy : function() {
		
		var EL = wpip.ui.el;

		if(wpip.autoDo) {wpip.startstop();}
		if(wpip.autoTimer) clearTimeout(wpip.autoTimer);
		if(wpip.fadeTimer) clearTimeout(wpip.fadeTimer);
		
		if(typeof wpip.thumbstrip !== 'undefined') {
			wpip.thumbstrip.reset();
		}
		
		wpip.clearProgressTimer();
		wpip.busyloading.off();
		wpip.cookie.write();

		$(document).off('keyup.ip keydown.ip contextmenu.ip');

		wpip.ui.showmenu(false);

		EL.slowtext.removeClass().addClass("overlay-wrapper-hide");
		

		wpip.collection.clear();
		
		wpip.captions.teardown();
		
		wpip.ui.autohide.teardown();

		wpip.isOpen = false;

		
		EL.ipwrapper.css({'opacity':0,'transition':'opacity .3s linear'});

		EL.ipwrapper.one(wpip.transitionEnd, function(e) {
			EL.underlay.removeAttr('style');
			EL.imgall.removeAttr('style width height');
			EL.allslides.removeAttr('style width height');
			EL.wrapper.removeAttr('style');	
			EL.ipwrapper.css({'display':'none'});

		});		

	}
} // end of Image Projector
var ipItem = function() {
	this.load = function(img) {

		
		img.attr({'src':this.src});
	
		var imgLoad = imagesLoaded(img);
		
		$(document).trigger("loadingimage.ip");

		imgLoad.once( 'done', function( instance ) {
			w = imgLoad.images[0].img.naturalWidth;
			h = imgLoad.images[0].img.naturalHeight;
			img.attr({'width':w, 'height':h});
			img.attr({'data-ratio':w/h});
			this.width = w;
			this.height = h;

			img.trigger("imageloaded");
		});
		imgLoad.once( 'fail', function() {

			img.attr({'src':wpip.wpdata.wpPluginUrl+'/public/img/wpiv-theimage.gif',
				'width':this.width,
				'height':this.height});
			img.trigger("imageloaded");
			console.log("Could not load, empty image shown. Please try sliding again.");
		});	

	}
}

function ipGetTransformTranslate(x,y, space) {
	return (
		'translate'+((space)?'3d':'')+'('+ x + 'px,'+ y + 'px'+((space)?',0px':'')+')'
	);
}
function ipGetTransformScale(f, space) {
	return (
		'scale'+((space)?'3d('+f+','+f+',1)':'('+f+')')
	);
} 
$.fn.extend({

	hidecmd: function () {
		this.addClass("ip-cmd-hide");	
	},
	showcmd: function () {
		this.removeClass("ip-cmd-hide");
	},

    sizeandcenter: function (sz, animate) {
		var transition = (animate) ? "all 0.4s ease" : "none";

		this.css({"width":sz.w+'px',"height":sz.h+'px',"top":sz.t+'px',"left":sz.l+'px','transition':transition});

		return this;
    },	
	slidexy: function(x, y, space, animate, duration){
		if(typeof duration === 'undefined') duration = 0.4;		
		
		var transition = (animate) ? "transform "+duration+"s ease-out" : "transform"; 
	

	
		this.css({'transition':transition, 'transform': ipGetTransformTranslate(x, y, space)});

	},
	setleft: function(left) {
	
		this.css({'transition':'none','transform':'none','left':left+'px'});
		
	},
	swapclass: function(outC, inC) {
		this.removeClass(outC).addClass(inC);
	}
});

})( jQuery, window, document );